import os

import click

from .pushy import Pushy
from .config import Config, PUSHY_CONFIG_DIR


@click.group()
@click.pass_context
def cli(ctx):
    config = Config()
    log_file = os.path.join(PUSHY_CONFIG_DIR, 'log')
    if os.path.exists(log_file):
        os.remove(log_file)
    ctx.obj = Pushy(config, log_file)


@cli.command()
@click.pass_context
def run(ctx):
    ctx.obj()


@cli.command()
@click.pass_context
def config(ctx):
    user_settings = ctx.obj.config.configure_settings({}, prompt_user=True)
    ctx.obj.config.write_settings(user_settings)
    click.echo('pushy-git reconfigured!')


@cli.command()
@click.pass_context
def hidden(ctx):
    user_settings = ctx.obj.config.configure_settings({}, prompt_user=True,
                                                      prompt_hidden=True)
    ctx.obj.config.write_settings(user_settings)
    click.echo('pushy-git hidden settings configured!')
