#!/usr/bin/env python3

from setuptools import setup, find_packages


setup(
    name='pushy-git',
    version='0.6.1',
    description='pushy-git automatically syncs local/remote branches',
    url='https://github.com/pshello/pushy-git.git',
    keywords='git cli automate, pushy',
    author='Patrick Schneeweis',
    author_email='psbleep@protonmail.com',
    license='GPLv3',
    classifiers=[
        'Development Status :: 3 - Alpha',
        'Environment :: Console',
        'Intended Audience :: Developers',
        'License :: OSI Approved :: GNU General Public License v3 (GPLv3)',
        'Operating System :: POSIX',
        'Programming Language :: Python :: 3.6',
        'Topic :: Utilities',
        'Topic :: Software Development :: Version Control :: Git',
    ],
    packages=find_packages(),
    include_package_data=True,
    python_requres='>=3',
    install_requires=[
        'click>=6.7',
    ],
    entry_points={
        'console_scripts': ['pushy-git=pushy.__main__:cli']
    }
)
